#include <bits/stdc++.h>
using namespace std;
long long N,NIZ[200005],X,Y,x,y,Q;
bool F=true;
int main(){
  cin>>N;
  for(int i=1;i<=N;i++){
    scanf("%lld",&X);
    if(X<Y)NIZ[i]=NIZ[i-1]+1;
    else NIZ[i]=NIZ[i-1];
    Y=X;
    if(X>2 or X==0)F=false;
  }
  cin>>Q;
  if(F){
        for(int i=1;i<=Q;i++){
           scanf("%lld",&x);
           scanf("%lld",&y);
            X=y-x;
            if(NIZ[y]-NIZ[x]==1){
            while(x<=y and NIZ[x]==NIZ[x+1]){
            x++;
            }
            if(y-x!=X)printf("NE\n");
            else printf("DA\n");
          }
          else printf("DA\n");
  }
  return 0;
  }
  for(int i=1;i<=Q;i++){
   scanf("%lld",&x);
   scanf("%lld",&y);
  if(NIZ[y]-NIZ[x]>1)printf("NE\n");
  else printf("DA\n");
  }
 return 0;
}